package cn.ecpark.service.usergw.biz.filters;

import org.springframework.boot.SpringBootConfiguration;
import org.springframework.cloud.gateway.filter.GatewayFilterChain;
import org.springframework.cloud.gateway.filter.GlobalFilter;
import org.springframework.core.annotation.Order;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.server.reactive.ServerHttpRequest;
import org.springframework.http.server.reactive.ServerHttpResponse;
import org.springframework.stereotype.Component;
import org.springframework.web.server.ServerWebExchange;

import lombok.extern.slf4j.Slf4j;
import reactor.core.publisher.Mono;

@Slf4j
@Component
@SpringBootConfiguration
@Order(-200)
public class VerifyFilter implements GlobalFilter {

    @Override
    public Mono<Void> filter(ServerWebExchange exchange, GatewayFilterChain chain) {
        
        if(true) return chain.filter(exchange);

        ServerHttpRequest request = exchange.getRequest();
        HttpHeaders header = request.getHeaders();

        ServerHttpResponse response = exchange.getResponse();
        HttpHeaders respHeader = response.getHeaders();
        respHeader.add("token-expire", String.valueOf(System.currentTimeMillis() / 1000));
        respHeader.add("version", "v0.0.1");

        String token = header.getFirst("token");
        if (token != null) {
            //
            if (VerifyToken(token)) {
                log.info("request token is Verify Successed: {}", token);
                return chain.filter(exchange);
            }
            log.info("request token is Verify Fail: {} != {}", token, TEST_TOKEN);
        } else {
            log.warn("request token is empty: {}", request.getURI());
        }

        if (!response.setStatusCode(HttpStatus.UNAUTHORIZED)) {
            log.error("if the status code has not been set because the HTTP response is already committed");
        }

        return response.setComplete();
    }

    public static final String TEST_TOKEN = "yame";

    public boolean VerifyToken(String token) {
        if (token.equals(TEST_TOKEN)) {
            return true;
        }
        return false;
    }



    

}