package cn.ecpark.service.usergw.utils;

import java.net.URI;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import org.assertj.core.util.Arrays;
import org.junit.Assert;
import org.junit.Test;
import org.springframework.boot.test.context.TestComponent;

import cn.ecpark.service.usergw.utils.Extract.GenericServiceBase;
import io.netty.handler.codec.http.HttpUtil;
import io.netty.handler.codec.http.QueryStringDecoder;

@TestComponent
public class TestExtract {

    @Test
    public void TestParseDubboUri() {
        GenericServiceBase gsb;
        gsb = Extract.GenericServiceBase.Parse("dubbo://application/test/com.a.b:1.0.0");
        Assert.assertNotNull("is Null", gsb);
        Assert.assertEquals(gsb.getApplication(), "application");
        Assert.assertEquals(gsb.getGroup(), "test");
        Assert.assertEquals(gsb.getInterface(), "com.a.b");
        Assert.assertEquals(gsb.getVersion(), "1.0.0");

        gsb = Extract.GenericServiceBase.Parse("dubbo://application/com.a.b:1.0.0");
        Assert.assertNotNull("is Null", gsb);
        Assert.assertEquals(gsb.getApplication(), "application");
        Assert.assertEquals(gsb.getInterface(), "com.a.b");
        Assert.assertEquals(gsb.getVersion(), "1.0.0");
    }

    @Test
    public void TestUriQueryList() {
        // String uriString = "dubbo://qu/ha?method=213&method=312";
        // QueryStringDecoder decode = new QueryStringDecoder(uriString);
        // URI uri = URI.create(uriString);
        // Map<String, List<String>> parameters = decode.parameters();
        // Assert.assertNotNull(uri);
        String[] _words = {"Hello", "World", "Hello"};
        Object owords = Arrays.asList(_words);
        List<String> words = (List<String>) owords;
        List<String[]> a = words.stream().map(word -> ((String) word).split("e")).distinct().collect(Collectors.toList());
        
        System.out.println(a);
    }
}